/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Substitute the type names.  */
#define YYSTYPE         CQLSTYPE
/* Substitute the variable and function names.  */
#define yyparse         cqlparse
#define yylex           cqllex
#define yyerror         cqlerror
#define yydebug         cqldebug
#define yynerrs         cqlnerrs

#define yylval          cqllval
#define yychar          cqlchar

/* Copy the first part of user declarations.  */
#line 4 "cqpeval.y" /* yacc.c:339  */


#include "config.hh"
#include "finlib/fstream.hh"
#include "frsop.hh"
#include "corpus.hh"
#include "parsop.hh"
#include "utf8.hh"
#include "cqpeval.hh"

#include <iostream>
using namespace std;

string errMsg;

string query;
static ssize_t pos = -1;  // position after the current lexer token
static ssize_t startpos = -1;  // position before the current lexer token
static bool onepos = false;

extern "C" {
     int yyparse(void);
     int yylex(void);
     void yyerror(char const* s) {
          stringstream ss;
          ss << s << " near position " << utf8pos(query.c_str(), startpos);
          errMsg = ss.str();
     }
     int cqlwrap() {
          return 1;
     }
}

Corpus* currCorp, *alCorp, *tmpCorp;
Corpus* defaultCorp;
Structure* currStruc;
Position lastPosition;

PosAttr* getAttr(string name) {
     return currCorp->get_attr(name);
}

PosAttr* getAttr(const char* name) {
     string s(name);
     return getAttr(s);
}

const char* unescapeString(const char* s) {
     size_t len = strlen(s);
     char* unescaped = new char[len+1];
     size_t i, j;
     for (i = 0, j = 0; i < len; i++, j++) {
          if (s[i] == '\\' && i + 1 < len && (s[i + 1] == '"' || s[i + 1] == '\\'))
               i++;
          unescaped[j] = s[i];
     }
     unescaped[j] = '\0';
     return unescaped;
}

FastStream* exactMatch(const char* attrName, const char* str) {
    PosAttr* attr = getAttr(attrName);
    int id = attr->str2id(unescapeString(str));
     return attr->id2poss(id);
}

const int WORD_LESS_OR_EQUALS = -1;
const int WORD_GREATER_OR_EQUALS = 1;
const bool ignoreCase = false;

struct globOp {
     RQFilterFreq::Op op;
     int neg;
};

struct rep {
     int min, max;
};

struct evalResult {
     RangeStream* r;
     FastStream* f;
     int fcount;
     RangeStream* toRangeStream() {
          if (f != NULL) {
               return new Pos2Range(f, 0, fcount);
          }
          return r;
     }
     evalResult complement() {
          RangeStream* r = toRangeStream();
          evalResult ret;
          ret.f = NULL;
          ret.fcount = 0;
          ret.r = new RQoutsideNode(r, defaultCorp->size());
          return ret;
     }
};

evalResult createEvalResult(FastStream* f, int count=1) {
     evalResult ret;
     ret.r = NULL;
     ret.f = f;
     ret.fcount = count;
     return ret;
}

evalResult createEvalResult(RangeStream* r) {
     evalResult ret;
     ret.r = r;
     ret.f = NULL;
     ret.fcount = 0;
     return ret;
}

evalResult concat(evalResult e1, evalResult e2) {
     RangeStream* r1 = e1.r;
     RangeStream* r2 = e2.r;
     if (r1 != NULL || r2 != NULL) {
          bool sortBeg = false;
          if (r1 == NULL) {
               r1 = e1.toRangeStream();
          } else {
               r1 = new RQSortEnd(r1);
               sortBeg = true;
          }
          if (r2 == NULL) {
               r2 = e2.toRangeStream();
          }
          RangeStream* c = RQConcatNodeUnsort(r1, r2);
          if (sortBeg) {
               c = new RQSortBeg(c);
          }
          return createEvalResult(c);
     }
     FastStream* c = new QAndNode(e1.f, new QMoveNode(e2.f, -1*e1.fcount));
     return createEvalResult(c, e1.fcount + e2.fcount);
}

evalResult operationOr(evalResult e1, evalResult e2) {
     RangeStream* r1 = e1.r;
     RangeStream* r2 = e2.r;
     if (r1 != NULL || r2 != NULL || e1.fcount != e2.fcount) {
          if (r1 == NULL) {
               r1 = e1.toRangeStream();
          }
          if (r2 == NULL) {
               r2 = e2.toRangeStream();
          }
          return createEvalResult(new RQUnionNode(r1, r2));
     }
     return createEvalResult(new QOrNode(e1.f, e2.f), e1.fcount);
}


FastStream* concatFs(FastStream* f1, FastStream* f2) {
     return new QAndNode(f1, new QMoveNode(f2, -1));
}

evalResult queryResult;


#line 238 "cqpeval.cc" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif


/* Debug traces.  */
#ifndef CQLDEBUG
# if defined YYDEBUG
#if YYDEBUG
#   define CQLDEBUG 1
#  else
#   define CQLDEBUG 0
#  endif
# else /* ! defined YYDEBUG */
#  define CQLDEBUG 0
# endif /* ! defined YYDEBUG */
#endif  /* ! defined CQLDEBUG */
#if CQLDEBUG
extern int cqldebug;
#endif

/* Token type.  */
#ifndef CQLTOKENTYPE
# define CQLTOKENTYPE
  enum cqltokentype
  {
    START_QUERY = 258,
    START_ONEPOS = 259,
    WORD = 260,
    REGEXP = 261,
    LBRACKET = 262,
    RBRACKET = 263,
    LPAREN = 264,
    RPAREN = 265,
    LBRACE = 266,
    RBRACE = 267,
    NOT = 268,
    EQ = 269,
    NEQ = 270,
    LEQ = 271,
    GEQ = 272,
    LSTRUCT = 273,
    RSTRUCT = 274,
    BIN_AND = 275,
    BIN_OR = 276,
    STAR = 277,
    PLUS = 278,
    QUEST = 279,
    SLASH = 280,
    POSNUM = 281,
    COMMA = 282,
    COLON = 283,
    DOT = 284,
    TEQ = 285,
    NNUMBER = 286,
    NUMBER = 287,
    KW_MEET = 288,
    KW_UNION = 289,
    KW_WITHIN = 290,
    KW_CONTAINING = 291,
    KW_WS = 292,
    KW_SWAP = 293,
    KW_CCOLL = 294,
    KW_FREQ = 295,
    KW_TERM = 296
  };
#endif
/* Tokens.  */
#define START_QUERY 258
#define START_ONEPOS 259
#define WORD 260
#define REGEXP 261
#define LBRACKET 262
#define RBRACKET 263
#define LPAREN 264
#define RPAREN 265
#define LBRACE 266
#define RBRACE 267
#define NOT 268
#define EQ 269
#define NEQ 270
#define LEQ 271
#define GEQ 272
#define LSTRUCT 273
#define RSTRUCT 274
#define BIN_AND 275
#define BIN_OR 276
#define STAR 277
#define PLUS 278
#define QUEST 279
#define SLASH 280
#define POSNUM 281
#define COMMA 282
#define COLON 283
#define DOT 284
#define TEQ 285
#define NNUMBER 286
#define NUMBER 287
#define KW_MEET 288
#define KW_UNION 289
#define KW_WITHIN 290
#define KW_CONTAINING 291
#define KW_WS 292
#define KW_SWAP 293
#define KW_CCOLL 294
#define KW_FREQ 295
#define KW_TERM 296

/* Value type.  */
#if ! defined CQLSTYPE && ! defined CQLSTYPE_IS_DECLARED

union CQLSTYPE
{
#line 167 "cqpeval.y" /* yacc.c:355  */

     long long num;
     const char* str;
     evalResult evalRes;
     FastStream* fs;
     RangeStream* rs;
     rep repData;
     globOp globop;
     int i;

#line 376 "cqpeval.cc" /* yacc.c:355  */
};

typedef union CQLSTYPE CQLSTYPE;
# define CQLSTYPE_IS_TRIVIAL 1
# define CQLSTYPE_IS_DECLARED 1
#endif


extern CQLSTYPE cqllval;

int cqlparse (void);



/* Copy the second part of user declarations.  */

#line 393 "cqpeval.cc" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined CQLSTYPE_IS_TRIVIAL && CQLSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  40
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   355

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  42
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  33
/* YYNRULES -- Number of rules.  */
#define YYNRULES  112
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  228

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   296

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41
};

#if CQLDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   203,   203,   207,   214,   218,   222,   229,   233,   237,
     244,   248,   255,   260,   265,   270,   275,   280,   285,   290,
     298,   302,   308,   312,   318,   322,   326,   332,   336,   340,
     347,   351,   355,   362,   370,   370,   384,   384,   398,   402,
     406,   410,   417,   421,   428,   432,   449,   454,   458,   466,
     470,   474,   481,   486,   491,   496,   501,   509,   514,   513,
     526,   530,   537,   541,   545,   549,   553,   557,   564,   572,
     583,   591,   602,   606,   613,   617,   635,   639,   646,   653,
     657,   664,   668,   674,   674,   674,   674,   674,   674,   675,
     675,   675,   675,   679,   687,   698,   702,   707,   711,   716,
     720,   725,   729,   734,   738,   742,   746,   750,   760,   770,
     781,   792,   798
};
#endif

#if CQLDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "START_QUERY", "START_ONEPOS", "WORD",
  "REGEXP", "LBRACKET", "RBRACKET", "LPAREN", "RPAREN", "LBRACE", "RBRACE",
  "NOT", "EQ", "NEQ", "LEQ", "GEQ", "LSTRUCT", "RSTRUCT", "BIN_AND",
  "BIN_OR", "STAR", "PLUS", "QUEST", "SLASH", "POSNUM", "COMMA", "COLON",
  "DOT", "TEQ", "NNUMBER", "NUMBER", "KW_MEET", "KW_UNION", "KW_WITHIN",
  "KW_CONTAINING", "KW_WS", "KW_SWAP", "KW_CCOLL", "KW_FREQ", "KW_TERM",
  "$accept", "list", "query", "globCond", "globPart", "globCondCmp",
  "within_containing", "within_containing_sufix", "within_number",
  "aligned_part_labels", "$@1", "aligned_part_no_labels", "$@2",
  "sequence", "seq", "repetition", "atomQuery", "repOpt", "structure",
  "$@3", "position", "oneposition", "thesaurus", "thesaurus_default",
  "muPart", "meetOp", "integer", "unionOp", "attvallist", "attvaland",
  "word", "wsseek", "attval", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296
};
# endif

#define YYPACT_NINF -96

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-96)))

#define YYTABLE_NINF -58

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      58,     6,   230,    35,   -96,   193,   190,   123,   247,    15,
      51,    92,    17,    44,   -96,   158,   123,   -96,   169,   -96,
     -96,   -96,   -96,   -96,   230,   230,   -16,   -96,   -96,   -96,
     -96,    84,    87,   122,   -96,   124,    88,   118,   287,   -96,
     -96,   -96,   134,     9,   231,   283,   283,    92,   135,   137,
     144,   162,   123,    47,   -96,   -96,   -96,   -96,    70,   115,
     -96,   168,    16,    77,    85,   130,    -6,   143,   -96,   149,
     -96,   -96,   -96,   -96,    18,   -96,   145,    21,   153,   156,
      25,   230,   230,   220,    96,   100,   194,   215,   -96,   -96,
      26,   221,   283,   283,   -96,   -96,   -96,   -96,   206,   -96,
     219,   230,   -96,   -96,   177,   177,    36,    51,   -96,   -96,
     -96,   252,   212,    36,   -96,   -96,   246,   270,   123,   123,
       2,   -96,   -96,   264,   278,   279,   281,   282,   284,   118,
     -96,   301,   304,   -96,   306,   -96,   308,   -96,   -96,   -96,
     310,   226,   -96,   -96,   -96,    88,   244,   -96,   -96,   289,
     -96,   -96,   -96,   -96,   -96,   -96,    47,   286,   123,   -96,
     288,   313,   290,   230,   291,   315,   290,   -96,   -96,   -96,
     -96,   -96,   -96,   -96,   226,   -96,     6,   245,   295,   314,
     298,   299,   318,    23,   302,   303,   321,   -96,     6,   252,
     300,   305,    47,   -96,   327,   307,   -96,   -96,   230,   328,
     -96,   252,   309,   311,   325,   326,   -96,    57,   331,    47,
      47,   280,   -96,   -96,   -96,   -96,   -96,   261,   -96,   -96,
     -96,   -96,   -96,   -96,   312,   -96,   -96,   -96
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     0,     0,     0,    62,     0,     0,     0,     0,     0,
       0,     2,     5,     0,     6,     4,    38,    42,    44,    49,
      60,    65,    66,    83,     0,     0,     0,    84,    85,    86,
      87,    89,    91,    92,    88,    90,     3,    79,     0,    81,
       1,    67,     0,     0,     0,     0,     0,     0,     6,     4,
       0,     0,    39,     0,    89,    91,    92,    90,     0,    58,
      71,     0,     0,     0,     0,     0,     0,     0,    43,     0,
      52,    53,    54,    45,     0,   105,   103,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    64,    63,
       0,     0,     0,     0,    51,    50,    72,    73,     0,    46,
       0,     0,    70,    61,     0,     0,     0,    33,    20,    30,
      24,    32,     0,     0,    22,    27,     0,     0,     0,    40,
       0,   106,   104,     0,     0,     0,     0,     0,     0,    80,
      82,     0,     0,    95,     0,    96,     0,    99,   101,    69,
       0,    74,    78,    48,    47,    59,     0,    21,    26,     0,
      23,    29,    31,    25,    34,    28,     0,     0,    41,    55,
       0,     0,     0,     0,     0,     0,     0,   100,   102,    97,
      98,    68,    77,    76,     0,    36,     0,     0,     0,     0,
       0,    93,     0,     0,     0,     0,     0,    75,     0,    35,
       0,     0,     0,    56,     0,     0,   107,   111,     0,     0,
     108,    37,     0,     0,     0,     0,    94,     0,     0,     0,
       0,     0,   109,   112,   110,     7,     8,     0,    12,    13,
      14,    15,    16,    18,     0,    19,    17,     9
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
     -96,   -96,   336,   -96,   -96,   -96,   337,   -55,   -95,   285,
     -96,   136,   -96,     1,    -2,   -12,   -96,   -96,   292,   -96,
     -37,   293,   -96,   -96,   -96,   -96,   172,   -96,    -4,   266,
      -5,   182,   -19
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     3,    11,    12,    13,   224,    14,   108,   109,   110,
     176,   148,   188,   111,    16,    17,    18,    73,    58,   101,
      19,    20,    42,    21,    22,    50,   174,    51,    36,    37,
      38,   182,    39
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      44,    43,    15,    59,    68,    52,    75,    49,    92,    93,
     114,   152,     4,     5,   159,     6,    76,    89,   152,     7,
      74,    60,     4,     5,     8,    91,   116,   123,   121,   160,
      81,   127,   139,   197,   117,    40,     9,   -10,    10,    81,
      68,    23,     4,     5,    81,     6,     9,    61,    59,   147,
     150,   152,    23,   124,     8,   141,   142,   128,   140,   112,
     112,     1,     2,   130,    66,   119,     9,   213,   107,    27,
      28,    29,    30,    54,    55,    56,    34,    57,    81,    62,
      27,    28,    29,    30,    54,    55,    56,    34,    57,    99,
      23,     4,     5,    77,     6,   100,    78,   145,   106,   149,
     149,   149,   133,     8,    52,    63,   135,    68,   149,    81,
     134,    52,   104,   105,   136,     9,   158,   107,    27,    28,
      29,    30,    54,    55,    56,    34,    57,    64,    65,     4,
       5,    79,     6,    80,   -57,    23,     4,     5,    82,     6,
     -57,     8,    88,   113,    52,    94,    68,    95,     8,     4,
       5,   177,     6,     9,    96,    10,   118,   -11,    67,   183,
       9,     8,   107,    27,    28,    29,    30,    54,    55,    56,
      34,    57,    97,     9,   102,    10,   122,   189,   -11,    67,
      69,   120,    23,     4,     5,   125,     6,   204,   126,   201,
     146,    70,    71,    72,   207,     8,     4,     5,    23,     6,
     137,    41,    24,     7,   215,   216,    25,     9,     8,   107,
      27,    28,    29,    30,    54,    55,    56,    34,    57,    26,
       9,   138,    10,    45,    46,   143,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    23,   131,   132,   144,    24,
     154,   151,   153,    25,    83,    84,    85,    86,    87,   155,
       4,     5,    23,     6,    45,    46,    26,   172,   173,   190,
     191,    90,     8,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    53,    67,     9,   156,   107,   225,   226,   157,
      27,    28,    29,    30,    54,    55,    56,    34,    57,     4,
       5,   161,    91,   217,   218,   219,   220,   221,   222,   223,
      83,    84,    85,    86,    87,   162,   163,   167,   164,   165,
     168,   166,   169,     9,   170,    10,   171,   175,   178,   180,
     179,   185,   181,   184,   192,   194,   193,   195,   196,   198,
     199,   200,   202,   205,   208,   211,   212,   203,   209,   206,
     210,   214,    47,    48,   227,    98,   187,   129,   186,     0,
     115,     0,     0,     0,     0,   103
};

static const yytype_int16 yycheck[] =
{
       5,     5,     1,     8,    16,     7,    25,     6,    45,    46,
      65,   106,     6,     7,    12,     9,    32,     8,   113,    13,
      24,     6,     6,     7,    18,     9,    32,     6,    10,    27,
      21,     6,     6,    10,    40,     0,    30,    20,    32,    21,
      52,     5,     6,     7,    21,     9,    30,    32,    53,   104,
     105,   146,     5,    32,    18,    92,    93,    32,    32,    64,
      65,     3,     4,    82,    20,    67,    30,    10,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    21,    28,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    19,
       5,     6,     7,     9,     9,    25,     9,   101,    13,   104,
     105,   106,     6,    18,   106,    13,     6,   119,   113,    21,
      14,   113,    35,    36,    14,    30,   118,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    35,    36,     6,
       7,     9,     9,     9,    19,     5,     6,     7,    20,     9,
      25,    18,     8,    13,   146,    10,   158,    10,    18,     6,
       7,   156,     9,    30,    10,    32,    13,    20,    21,   163,
      30,    18,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    10,    30,     6,    32,    31,   176,    20,    21,
      11,    32,     5,     6,     7,    32,     9,   192,    32,   188,
      13,    22,    23,    24,   198,    18,     6,     7,     5,     9,
       6,     8,     9,    13,   209,   210,    13,    30,    18,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    26,
      30,     6,    32,    33,    34,    19,    33,    34,    35,    36,
      37,    38,    39,    40,    41,     5,    16,    17,    19,     9,
      28,   105,   106,    13,    13,    14,    15,    16,    17,   113,
       6,     7,     5,     9,    33,    34,    26,    31,    32,    14,
      15,    30,    18,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    25,    21,    30,    29,    32,    16,    17,     9,
      33,    34,    35,    36,    37,    38,    39,    40,    41,     6,
       7,    27,     9,    13,    14,    15,    16,    17,    18,    19,
      13,    14,    15,    16,    17,    27,    27,     6,    27,    27,
       6,    27,     6,    30,     6,    32,     6,    28,    32,     6,
      32,     6,    32,    32,    29,    27,    12,    28,    10,    27,
      27,    10,    32,     6,     6,    10,    10,    32,    29,    32,
      29,    10,     6,     6,    32,    53,   174,    81,   166,    -1,
      65,    -1,    -1,    -1,    -1,    62
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,    43,     6,     7,     9,    13,    18,    30,
      32,    44,    45,    46,    48,    55,    56,    57,    58,    62,
      63,    65,    66,     5,     9,    13,    26,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    70,    71,    72,    74,
       0,     8,    64,    70,    72,    33,    34,    44,    48,    55,
      67,    69,    56,    25,    37,    38,    39,    41,    60,    72,
       6,    32,    28,    13,    35,    36,    20,    21,    57,    11,
      22,    23,    24,    59,    70,    74,    32,     9,     9,     9,
       9,    21,    20,    13,    14,    15,    16,    17,     8,     8,
      30,     9,    62,    62,    10,    10,    10,    10,    60,    19,
      25,    61,     6,    63,    35,    36,    13,    32,    49,    50,
      51,    55,    72,    13,    49,    51,    32,    40,    13,    56,
      32,    10,    31,     6,    32,    32,    32,     6,    32,    71,
      74,    16,    17,     6,    14,     6,    14,     6,     6,     6,
      32,    62,    62,    19,    19,    70,    13,    49,    53,    72,
      49,    53,    50,    53,    28,    53,    29,     9,    56,    12,
      27,    27,    27,    27,    27,    27,    27,     6,     6,     6,
       6,     6,    31,    32,    68,    28,    52,    72,    32,    32,
       6,    32,    73,    70,    32,     6,    73,    68,    54,    55,
      14,    15,    29,    12,    27,    28,    10,    10,    27,    27,
      10,    55,    32,    32,    72,     6,    32,    70,     6,    29,
      29,    10,    10,    10,    10,    72,    72,    13,    14,    15,
      16,    17,    18,    19,    47,    16,    17,    32
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    42,    43,    43,    44,    44,    44,    45,    45,    45,
      46,    46,    47,    47,    47,    47,    47,    47,    47,    47,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      49,    49,    49,    50,    52,    51,    54,    53,    55,    55,
      55,    55,    56,    56,    57,    57,    57,    57,    57,    58,
      58,    58,    59,    59,    59,    59,    59,    60,    61,    60,
      62,    62,    63,    63,    63,    63,    63,    63,    64,    64,
      65,    65,    66,    66,    67,    67,    68,    68,    69,    70,
      70,    71,    71,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    73,    73,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     2,     1,     1,     1,     9,     9,    10,
       1,     1,     1,     1,     1,     1,     1,     2,     1,     2,
       3,     4,     3,     4,     3,     4,     4,     3,     4,     4,
       1,     2,     1,     1,     0,     4,     0,     4,     1,     2,
       3,     4,     1,     2,     1,     2,     3,     4,     4,     1,
       3,     3,     1,     1,     1,     3,     5,     1,     0,     3,
       1,     3,     1,     3,     3,     1,     1,     2,     4,     3,
       3,     2,     3,     3,     3,     5,     1,     1,     3,     1,
       3,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     4,     4,     3,
       4,     3,     4,     2,     3,     2,     3,     6,     6,     8,
       8,     6,     8
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if CQLDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !CQLDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !CQLDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 204 "cqpeval.y" /* yacc.c:1646  */
    {
          queryResult = (yyvsp[0].evalRes);
     }
#line 1654 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 3:
#line 208 "cqpeval.y" /* yacc.c:1646  */
    {
          queryResult = createEvalResult((yyvsp[0].fs));
     }
#line 1662 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 4:
#line 215 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 1670 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 5:
#line 219 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[0].rs));
     }
#line 1678 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 6:
#line 223 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[0].rs));
     }
#line 1686 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 7:
#line 230 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQFilterPos((yyvsp[-8].rs), getAttr((yyvsp[-4].str)), getAttr((yyvsp[0].str)), RQFilterPos::F_EQ, (yyvsp[-6].num), (yyvsp[-2].num));
     }
#line 1694 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 8:
#line 234 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQFilterPos((yyvsp[-8].rs), getAttr((yyvsp[-4].str)), getAttr((yyvsp[0].str)), RQFilterPos::F_NEQ, (yyvsp[-6].num), (yyvsp[-2].num));
     }
#line 1702 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 9:
#line 238 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQFilterFreq((yyvsp[-9].rs), getAttr((yyvsp[-3].str)), (yyvsp[-1].globop).op, (yyvsp[-1].globop).neg, (yyvsp[-5].num), (yyvsp[0].num));
     }
#line 1710 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 10:
#line 245 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].rs);
     }
#line 1718 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 11:
#line 249 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].evalRes).toRangeStream();
     }
#line 1726 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 12:
#line 256 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_EQ;
          (yyval.globop).neg = 0;
     }
#line 1735 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 13:
#line 261 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_EQ;
          (yyval.globop).neg = 1;
     }
#line 1744 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 14:
#line 266 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_LEQ;
          (yyval.globop).neg = 0;
     }
#line 1753 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 15:
#line 271 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_GEQ;
          (yyval.globop).neg = 0;
     }
#line 1762 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 16:
#line 276 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_GEQ;
          (yyval.globop).neg = 1;
     }
#line 1771 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 17:
#line 281 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_GEQ;
          (yyval.globop).neg = 1;
     }
#line 1780 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 18:
#line 286 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_LEQ;
          (yyval.globop).neg = 1;
     }
#line 1789 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 19:
#line 291 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.globop).op = RQFilterFreq::F_LEQ;
          (yyval.globop).neg = 1;
     }
#line 1798 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 20:
#line 299 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQinNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1806 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 21:
#line 303 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotInNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1814 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 22:
#line 309 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQcontainNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1822 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 23:
#line 313 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotContainNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1830 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 24:
#line 319 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQinNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1838 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 25:
#line 323 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotInNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1846 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 26:
#line 327 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotInNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1854 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 27:
#line 333 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQcontainNode((yyvsp[-2].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1862 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 28:
#line 337 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotContainNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1870 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 29:
#line 341 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQnotContainNode((yyvsp[-3].evalRes).toRangeStream(), (yyvsp[0].rs));
     }
#line 1878 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 30:
#line 348 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].rs);
     }
#line 1886 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 31:
#line 352 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = new RQoutsideNode((yyvsp[0].rs), defaultCorp->size());
     }
#line 1894 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 32:
#line 356 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = (yyvsp[0].evalRes).toRangeStream();
     }
#line 1902 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 33:
#line 363 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = new SequenceStream(0, lastPosition, defaultCorp->size());
          (yyval.rs) = new RQRepeatFSNode(f, (yyvsp[0].num), (yyvsp[0].num));
     }
#line 1911 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 34:
#line 370 "cqpeval.y" /* yacc.c:1646  */
    {
          tmpCorp = currCorp;
          alCorp = currCorp->get_aligned((yyvsp[-1].str));
          alCorp->set_default_attr(currCorp->get_default_attr()->name);
          currCorp = alCorp;
     }
#line 1922 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 35:
#line 377 "cqpeval.y" /* yacc.c:1646  */
    {
          currCorp = tmpCorp;
          (yyval.rs) = currCorp->map_aligned(alCorp, (yyvsp[0].evalRes).toRangeStream(), true);
     }
#line 1931 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 36:
#line 384 "cqpeval.y" /* yacc.c:1646  */
    {
          tmpCorp = currCorp;
          alCorp = currCorp->get_aligned((yyvsp[-1].str));
          alCorp->set_default_attr(currCorp->get_default_attr()->name);
          currCorp = alCorp;
     }
#line 1942 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 37:
#line 391 "cqpeval.y" /* yacc.c:1646  */
    {
          currCorp = tmpCorp;
          (yyval.rs) = currCorp->map_aligned(alCorp, (yyvsp[0].evalRes).toRangeStream(), false);
     }
#line 1951 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 38:
#line 399 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 1959 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 39:
#line 403 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes).complement();
     }
#line 1967 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 40:
#line 407 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = operationOr((yyvsp[-2].evalRes), (yyvsp[0].evalRes));
     }
#line 1975 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 41:
#line 411 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = operationOr((yyvsp[-3].evalRes), (yyvsp[0].evalRes).complement());
     }
#line 1983 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 42:
#line 418 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 1991 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 43:
#line 422 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = concat((yyvsp[-1].evalRes), (yyvsp[0].evalRes));
     }
#line 1999 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 44:
#line 429 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[0].evalRes);
     }
#line 2007 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 45:
#line 433 "cqpeval.y" /* yacc.c:1646  */
    {
          RangeStream* r = NULL;
          if ((yyvsp[0].repData).min == 0 && (yyvsp[0].repData).max == 1) {
               if ((yyvsp[-1].evalRes).r == NULL) {
                    r = (yyvsp[-1].evalRes).toRangeStream();
               } else {
                    r = (yyvsp[-1].evalRes).r;
               }
               r = new RQOptionalNode(r);
          } else if ((yyvsp[-1].evalRes).r == NULL) {
               r = new RQRepeatFSNode((yyvsp[-1].evalRes).f, (yyvsp[0].repData).min, (yyvsp[0].repData).max);
          } else {
               r = new RQRepeatNode((yyvsp[-1].evalRes).r, (yyvsp[0].repData).min, (yyvsp[0].repData).max);
          }
          (yyval.evalRes) = createEvalResult(r);
     }
#line 2028 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 46:
#line 450 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* begs = new BegsOfRStream((yyvsp[-1].rs));
          (yyval.evalRes) = createEvalResult(new Pos2Range(begs, 0, 0));
     }
#line 2037 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 47:
#line 455 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[-2].rs));
     }
#line 2045 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 48:
#line 459 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* ends = new EndsOfRStream((yyvsp[-1].rs));
          (yyval.evalRes) = createEvalResult(new Pos2Range(ends, 0, 0));
     }
#line 2054 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 49:
#line 467 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[0].fs));
     }
#line 2062 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 50:
#line 471 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = (yyvsp[-1].evalRes);
     }
#line 2070 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 51:
#line 475 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.evalRes) = createEvalResult((yyvsp[-1].rs));
     }
#line 2078 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 52:
#line 482 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 0;
          (yyval.repData).max = -1;
     }
#line 2087 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 53:
#line 487 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 1;
          (yyval.repData).max = -1;
     }
#line 2096 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 54:
#line 492 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = 0;
          (yyval.repData).max = 1;
     }
#line 2105 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 55:
#line 497 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = (yyvsp[-1].num);
          (yyval.repData).max = (yyvsp[-1].num);
     }
#line 2114 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 56:
#line 502 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.repData).min = (yyvsp[-3].num);
          (yyval.repData).max = (yyvsp[-1].num);
     }
#line 2123 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 57:
#line 510 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = currCorp->get_struct((yyvsp[0].str))->rng->whole();
     }
#line 2131 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 58:
#line 514 "cqpeval.y" /* yacc.c:1646  */
    {
          currStruc = currCorp->get_struct((yyvsp[0].str));
          currCorp = currStruc;
     }
#line 2140 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 59:
#line 519 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.rs) = currStruc->rng->part((yyvsp[0].fs));
          currCorp = defaultCorp;
     }
#line 2149 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 60:
#line 527 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2157 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 61:
#line 531 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new AddLabel((yyvsp[0].fs), (yyvsp[-2].num));
     }
#line 2165 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 62:
#line 538 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = currCorp->get_default_attr()->regexp2poss((yyvsp[0].str), ignoreCase);
     }
#line 2173 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 63:
#line 542 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2181 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 64:
#line 546 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2189 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 65:
#line 550 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2197 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 66:
#line 554 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2205 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 67:
#line 558 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new SequenceStream(0, lastPosition, defaultCorp->size());
     }
#line 2213 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 68:
#line 565 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, (yyvsp[-3].str), (yyvsp[0].str), (yyvsp[-1].num));
          #else
          throw EvalQueryException("thesaurus available in NoSketchEngine");
          #endif
     }
#line 2225 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 69:
#line 573 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, (yyvsp[-2].str), (yyvsp[0].str), 0);
          #else
          throw EvalQueryException("thesaurus not available in NoSketchEngine");
          #endif
     }
#line 2237 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 70:
#line 584 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, "-", (yyvsp[0].str), (yyvsp[-1].num));
          #else
          throw EvalQueryException("thesaurus not available in NoSketchEngine");
          #endif
     }
#line 2249 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 71:
#line 592 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          (yyval.fs) = id2thesposs(currCorp, "-", (yyvsp[0].str), 0);
          #else
          throw EvalQueryException("thesaurus not available in NoSketchEngine");
          #endif
     }
#line 2261 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 72:
#line 603 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2269 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 73:
#line 607 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2277 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 74:
#line 614 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = concatFs((yyvsp[-1].fs), (yyvsp[0].fs));
     }
#line 2285 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 75:
#line 618 "cqpeval.y" /* yacc.c:1646  */
    {
          int num1 = (yyvsp[-1].num);
          int num2 = (yyvsp[0].num);

          if (num1 == num2) {
               (yyval.fs) = concatFs((yyvsp[-3].fs), (yyvsp[-2].fs));
          } else if (num1 > num2) {
               (yyval.fs) = new EmptyStream();
          } else {
               RangeStream* r1 = new Pos2Range((yyvsp[-3].fs), 0, 1);
               RangeStream* r2 = new Pos2Range((yyvsp[-2].fs), -num2, -num1+1);
               (yyval.fs) = new BegsOfRStream(new RQinNode(r1, r2));
          }
     }
#line 2304 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 76:
#line 636 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.num) = (yyvsp[0].num);
     }
#line 2312 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 77:
#line 640 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.num) = (yyvsp[0].num);
     }
#line 2320 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 78:
#line 647 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QOrNode((yyvsp[-1].fs), (yyvsp[0].fs));
     }
#line 2328 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 79:
#line 654 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2336 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 80:
#line 658 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QOrNode((yyvsp[-2].fs), (yyvsp[0].fs));
     }
#line 2344 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 81:
#line 665 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[0].fs);
     }
#line 2352 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 82:
#line 669 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QAndNode((yyvsp[-2].fs), (yyvsp[0].fs));
     }
#line 2360 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 93:
#line 680 "cqpeval.y" /* yacc.c:1646  */
    {
          stringstream seek;
          seek << (yyvsp[0].num);
          char *ret = new char[seek.str().size() + 1]();
          seek.str().copy(ret, seek.str().size());
          (yyval.str) = ret;
     }
#line 2372 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 94:
#line 688 "cqpeval.y" /* yacc.c:1646  */
    {
          stringstream seek;
          seek << (yyvsp[-2].num) << ":" << (yyvsp[0].num);
          char *ret = new char[seek.str().size() + 1]();
          seek.str().copy(ret, seek.str().size());
          (yyval.str) = ret;
     }
#line 2384 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 95:
#line 699 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = getAttr((yyvsp[-2].str))->regexp2poss((yyvsp[0].str), ignoreCase);
     }
#line 2392 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 96:
#line 703 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = getAttr((yyvsp[-2].str))->regexp2poss((yyvsp[0].str), ignoreCase);
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2401 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 97:
#line 708 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = exactMatch((yyvsp[-3].str), (yyvsp[0].str));
     }
#line 2409 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 98:
#line 712 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = exactMatch((yyvsp[-3].str), (yyvsp[0].str));
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2418 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 99:
#line 717 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = getAttr((yyvsp[-2].str))->compare2poss((yyvsp[0].str), WORD_LESS_OR_EQUALS, ignoreCase);
     }
#line 2426 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 100:
#line 721 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = getAttr((yyvsp[-3].str))->compare2poss((yyvsp[0].str), WORD_LESS_OR_EQUALS, ignoreCase);
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2435 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 101:
#line 726 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = getAttr((yyvsp[-2].str))->compare2poss((yyvsp[0].str), WORD_GREATER_OR_EQUALS, ignoreCase);
     }
#line 2443 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 102:
#line 730 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* f = getAttr((yyvsp[-3].str))->compare2poss((yyvsp[0].str), WORD_GREATER_OR_EQUALS, ignoreCase);
          (yyval.fs) = new QNotNode(f, defaultCorp->size());
     }
#line 2452 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 103:
#line 735 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new SequenceStream((yyvsp[0].num), (yyvsp[0].num), defaultCorp->size());
     }
#line 2460 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 104:
#line 739 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new SequenceStream((yyvsp[-1].num), -1*(yyvsp[0].num), defaultCorp->size());
     }
#line 2468 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 105:
#line 743 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = new QNotNode((yyvsp[0].fs), defaultCorp->size());
     }
#line 2476 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 106:
#line 747 "cqpeval.y" /* yacc.c:1646  */
    {
          (yyval.fs) = (yyvsp[-1].fs);
     }
#line 2484 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 107:
#line 751 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          int level = (yyvsp[-3].num);
          (yyval.fs) = getWMapPoss(currCorp->get_conf("WSBASE"), level, (yyvsp[-1].str));
          delete [] (yyvsp[-1].str);
          #else
          throw EvalQueryException("word sketches not available in NoSketchEngine");
          #endif
     }
#line 2498 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 108:
#line 761 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          int level = (yyvsp[-3].num);
          (yyval.fs) = getWMapPoss(currCorp->get_conf("TERMBASE"), level, (yyvsp[-1].str));
          delete [] (yyvsp[-1].str);
          #else
          throw EvalQueryException("terms not available in NoSketchEngine");
          #endif
     }
#line 2512 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 109:
#line 771 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          const char* gr = (yyvsp[-3].str);
          const char *pat1 = (const char *) (yyvsp[-5].str);
          const char *pat2 = (const char *) (yyvsp[-1].str);
          (yyval.fs) = getWMapPossMatchingRegexp(currCorp->get_conf("WSBASE"), gr, pat1, pat2);
          #else
          throw EvalQueryException("word sketches not available in NoSketchEngine");
          #endif
     }
#line 2527 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 110:
#line 782 "cqpeval.y" /* yacc.c:1646  */
    {
          #ifdef MANATEE_SKETCH_ENGINE
          const char* gr = (yyvsp[-3].str);
          const char *pat1 = (const char *) (yyvsp[-5].str);
          const char *pat2 = (const char *) (yyvsp[-1].str);
          (yyval.fs) = getWMapPossMatchingRegexp(currCorp->get_conf("TERMBASE"), gr, pat1, pat2);
          #else
          throw EvalQueryException("terms not available in NoSketchEngine");
          #endif
     }
#line 2542 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 111:
#line 793 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* src = (yyvsp[-1].fs);
          int coll = (yyvsp[-3].num);
          (yyval.fs) = new SwapKwicColl(src, coll);
     }
#line 2552 "cqpeval.cc" /* yacc.c:1646  */
    break;

  case 112:
#line 799 "cqpeval.y" /* yacc.c:1646  */
    {
          FastStream* src = (yyvsp[-1].fs);
          int from = (yyvsp[-5].num);
          int to = (yyvsp[-3].num);
          (yyval.fs) = new ChangeLabel(src, from, to);
     }
#line 2563 "cqpeval.cc" /* yacc.c:1646  */
    break;


#line 2567 "cqpeval.cc" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 807 "cqpeval.y" /* yacc.c:1906  */


char cqlCurrChar() {
     return query[pos];
}

char cqlNextChar() {
     if (pos+1 == (ssize_t) query.size()) {
          return 0;
     }
     return query[pos+1];
}

char* readRegexp() {
     // read until another apostrophe (without backslash) is reached
     int from = pos;
     int slashes = 0;
     while (pos < (ssize_t) query.size() && (cqlCurrChar() != '"' || slashes % 2 == 1)) {
          if(cqlCurrChar() == '\\') {
               slashes++;
          } else {
               slashes = 0;
          }
          pos++;
     }
     int size = pos-from;
     char* regexp = (char*) malloc(sizeof(char)*(size+1));
     memcpy(regexp, &query[from], size);
     regexp[size] = '\0';
     pos++;
     return regexp;
}

bool cqlIsAlpha(char c) {
     return ('a' <= c && c <= 'z') || ('A' <= c && c <= 'Z');
}

bool cqlIsNumber(char c) {
     return '0' <= c && c <= '9';
}

void skipSpaces() {
     while (pos < (ssize_t) query.size() && (cqlCurrChar() == ' ' || cqlCurrChar() == '\t')) {
          pos++;
     }
}

long long readNumber() {
     int from = pos++;
     while (pos < (ssize_t) query.size() && cqlIsNumber(cqlCurrChar())) {
          pos++;
     }
     string numStr = query.substr(from, pos-from);
     return atoll(numStr.c_str());
}

string readWord() {
     int from = pos++;
     while (pos < (ssize_t) query.size() && (cqlIsAlpha(cqlCurrChar()) ||
        cqlCurrChar() == '_' || cqlCurrChar() == '@' || cqlIsNumber(cqlCurrChar()))) {
          pos++;
     }
     return query.substr(from, pos-from);
}

int yylex() {
     if (pos < 0) {
          pos = 0;
          if (onepos) return START_ONEPOS;
          else return START_QUERY;
     }

     startpos = pos;

     if (pos >= (ssize_t) query.size()) {
          return 0;
     }
     
     bool negativeNumber = (cqlCurrChar() == '-' && cqlIsNumber(cqlNextChar()));
     if (negativeNumber || cqlIsNumber(cqlCurrChar())) {
          if (negativeNumber) {
               pos++;
          }
          yylval.num = readNumber();
          if (negativeNumber) {
               yylval.num *= -1;
               return NNUMBER;
          }
          return NUMBER;
     }
     
     // word
     if (cqlIsAlpha(cqlCurrChar()) || cqlCurrChar() == '_') {
          string word = readWord();
          char* str = new char[word.size()+1];
          word.copy(str, word.size());
          str[word.size()] = '\0';
          yylval.str = str;
          if (word == "f")
               return KW_FREQ;
          if (word == "meet")
               return KW_MEET;
          if (word == "union")
               return KW_UNION;
          if (word == "within")
               return KW_WITHIN;
          if (word == "containing")
               return KW_CONTAINING;
          if (word == "ws")
               return KW_WS;
          if (word == "term")
               return KW_TERM;
          if (word == "swap")
               return KW_SWAP;
          if (word == "ccoll")
               return KW_CCOLL;
          return WORD;
     }

     char c = cqlCurrChar();
     char next = cqlNextChar();
     pos++;

     switch (c) {
          case '"':
          {
               char* s = readRegexp();
               yylval.str = s;
               return REGEXP;
          }
          case '\t': // skip
          case ' ':
               skipSpaces();
               return yylex();
          case '[':
               return LBRACKET;
          case ']':
               return RBRACKET;
          case '=':
               return EQ;
          case '<':
               if (next == '=') {
                    pos++;
                    return LEQ;
               }
               return LSTRUCT;
          case '>':
               if (next == '=') {
                    pos++;
                    return GEQ;
               }
               return RSTRUCT;
          case '&':
               return BIN_AND;
          case '|':
               return BIN_OR;
          case '!':
               if (next == '=') {
                    pos++;
                    return NEQ;
               }
               return NOT;
          case '(':
               return LPAREN;
          case ')':
               return RPAREN;
          case '{':
               return LBRACE;
          case '}':
               return RBRACE;
          case '*':
               return STAR;
          case '+':
               return PLUS;
          case '?':
               return QUEST;
          case '/':
               return SLASH;
          case '#':
               return POSNUM;
          case ',':
               return COMMA;
          case ':':
               return COLON;
          case '.':
               return DOT;
          case '~':
               return TEQ;
          case ';':
               if (pos == (ssize_t) query.size()) {
                    return 0;
               }
               break;
     }

     std::ostringstream ss;
     ss << "unexpected character";
     if(c>=32 && c<=127) ss << " " << c;
     ss << " at position " << utf8pos(query.c_str(), pos);
     throw EvalQueryException(ss.str());
}

evalResult eval(const char* cqpQuery, Corpus *corp, bool eval_onepos) {
     if (!corp)
          throw EvalQueryException ("Internal Error: eval_cqpquery(corp==NULL)");
     if (!cqpQuery)
          throw EvalQueryException ("Internal Error: eval_cqpquery(query==NULL)");
     if (!*cqpQuery)
          throw EvalQueryException ("Internal Error: eval_cqpquery(query[0]==NULL)");

     defaultCorp = corp;
     currCorp = defaultCorp;
     lastPosition = defaultCorp->size()-1;
     query = cqpQuery;
     pos = -1;
     startpos = -1;
     onepos = eval_onepos;

     int ret = yyparse();

     if (ret != 0) {
          throw EvalQueryException(errMsg);
     }
     return queryResult;
}

RangeStream *eval_cqpquery (const char *query, Corpus *corp) {
     evalResult res = eval(query, corp, false);
     return res.toRangeStream();
}

FastStream *eval_cqponepos (const char *query, Corpus *corp) {
     evalResult res = eval(query, corp, true);
     if (res.f == NULL) {
          throw EvalQueryException("Not one pos query");
     }
     return res.f;
}

// vim: ts=4 sw=4 sta et sts=4 si cindent tw=80:
